function Animation(){
  this.images = new Array();
  this.timing = new Array();
  this.tempTime = GetTime();
  this.something = 0;
  this.total = 0;
  this.changed = false
}

Animation.prototype.addImage = function(unknown, timing){
  if(typeof unknown == "string"){
    this.images[this.images.length] = LoadImage(unknown);
  } else {
    this.images[this.images.length] = unknown;
  }
  this.timing[this.timing.length] = this.total + timing;
  this.total += timing;
}

Animation.prototype.reset = function(){
  this.something = 0;
  this.changed = false;
  this.tempTime = GetTime();
}

Animation.prototype.blit = function(x, y){
  while(GetTime() - this.tempTime >= this.total){
    this.tempTime += this.total;
  }
  for(var i = 0; i < this.timing.length; i++){
    if(GetTime() - this.tempTime <= this.timing[i]){
      if(this.changed) this.changed = false;
      if(this.something != i) this.changed = true;
      this.images[this.changed?this.something:i].blit(x, y);
      this.something = i;
      return;
    }
  }
}

Animation.prototype.blitMirror = function(x, y){
  while(GetTime() - this.tempTime >= this.total){
    this.tempTime += this.total;
  }
  for(var i = 0; i < this.timing.length; i++){
    if(GetTime() - this.tempTime <= this.timing[i]){
      if(this.changed) this.changed = false;
      if(this.something != i) this.changed = true;
      BlitMirror(this.images[this.changed?this.something:i], x, y);
      this.something = i;
      return;
    }
  }
}
