EvaluateSystemScript("screen.js");
EvaluateSystemScript("time.js");

var globalFlag1 = false;
var globalFlag2 = false;
var introDone = false;
var font = LoadFont("main.rfn")
var window = LoadWindowStyle("window.rws");
var weather = 0;
var menuKey = KEY_ESCAPE;
var speakKey = KEY_ENTER;
var fightKey = KEY_SPACE;
var melt = true;
var HP = 100;

var particle = new Array(200);
for(var i = 0; i < 200; i++){
  particle[i] = new Object();
  particle[i].x = Math.random()*GetScreenWidth();
  particle[i].y = Math.random()*GetScreenHeight();
  particle[i].rad = Math.random()*2*Math.PI;
  particle[i].strength = 40;
  particle[i].dx = Math.random() + .25;
}

EvaluateScript("textSystem.js");
EvaluateScript("menuSystem.js");
EvaluateScript("bs.js");
EvaluateScript("conversations.js");

function game(){
  Begin();
  Intro("Bob");
}

function GoGoGagetBattle(level){
  HP = bs(HP, level);
  return HP;
}

function Begin(){
  var music = LoadSound("begin.it");
  var splash2 = LoadImage("fenix.png");
  var splash = LoadImage("sphere.png");
  var titleScreen = LoadImage("title.png");
  ClearScreen();
  FlipScreen();
  music.play(false);
  splash.blit(0, 0);
  if(!IsKeyPressed(KEY_ESCAPE))Delay(8000);
  if(!IsKeyPressed(KEY_ESCAPE))FadeIn(4000);
  if(!IsKeyPressed(KEY_ESCAPE))Delay(4000);
  if(!IsKeyPressed(KEY_ESCAPE))FadeOut(4000);
  if(!IsKeyPressed(KEY_ESCAPE))Delay(4000);
  splash2.blit(0, 4);  
  if(!IsKeyPressed(KEY_ESCAPE))FadeIn(4000);
  if(!IsKeyPressed(KEY_ESCAPE))Delay(4000);
  if(!IsKeyPressed(KEY_ESCAPE))FadeOut(4000);
  if(!IsKeyPressed(KEY_ESCAPE))Delay(8000);
  titleScreen.blit(0, 0);
  FlipScreen();
  if(!IsKeyPressed(KEY_ESCAPE))Delay(4000);
  music.stop();
  delete music;
  while(AreKeysLeft()) GetKey(); GetKey();
  titleScreen.blit(0, 0);
  Melt(4);
}

function Intro(name){
  var music = LoadSound("outside.it");
  music.play(true);
  if(!IsKeyPressed(KEY_ESCAPE)){
    Speak("Voice", "The City of the Damned.\n\tSometime in the late 22nd century. All weapons were destroyed in an attempt to rid the Earth of all crime, the black market was eradiated by a mandatory \"attitude correction\" (ACOR) chip implanted in all babies since the year 2108. Crime seemed to be eradicated. The world was almost perfect. But one day a virus was created by the underground society which avoided the ACOR implants. The virus corrupted all people and the crime rate began to shoot through the roof. Due to the lack of knowledge of standardized weapons and the leap in nanotechnology, a biotechnic weapon system was created. Energy generated by the brain could be focused by electronics and projected outward to create swords of energy. These weapons could be created stronger with extreme focus in the human brain. Thus the neo-monks were born. These monks, would meditate for extended amounts of time, gaining more knowledge on the workings of their minds. These monks gained power and a system of organized crime was created. The organized crime members became known as the GMTLSY, the Great Many Thoughts of Lucifer: Satan's Yearnings.");
    Speak("Voice", "You are Orrin Jacobson. A man for hire, after your town was viciously massacred through the murderous rampage of one of the underground, you vowed to get revenge on those who wronged your family.\n\tMany years have passed since you've discovered yourself working for the same people who massacred your town. Everything you've fought for seems to have gone into the grey fog which you surround your path with. There are too many people above you for you to obtain your revenge. Only a person with nothing to lose would be able to accomplish this feat. Little do you know, you are about to obtain that trait.")
    FlipScreen(); FlipScreen();
    Delay(1000);
    Speak("Jedd", "Orrin, I need you to watch over my daughter when I am gone. Protect her, there are many people who want my family... our family to be hurt. You understand, don't you?");
    Speak("Orrin", "Yes sir. Nothing will happen to her.");
    Speak("Orrin [internally]", "This man...I am so close to... He must pay... I cannot sacrifice my life...");
    Speak("Jedd", "Sarah, come in here.");
    Speak("Sarah", "Yes daddy?");
    Speak("Jedd", "Sarah, this is Orrin Jacobson, he will be watching over you while I am gone. Please treat him with proper respect.");
    Speak("Sarah", "Why hello.");
    var blam = LoadImage("blam.png");
    FlipScreen(); FlipScreen();
    Delay(1000);
    Speak("Voice", "Two days later.");
    Speak("John", "Well, as I was saying....");
    Speak("Sarah", "Orrin! Can I get this??? Can I??? Can I???");
    Speak("Orrin", "I supp..");
    for(var i = 0; i < 20; i++){
      blam.blit(0, 0);
      FlipScreen();
      Delay(40);
      Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(255, 255, 255));
      FlipScreen();
      Delay(40);
    }
    Speak("Various Voices", "OH MY GOD!!!! What the hell was that!??!? AYEEEEEE!!!!");
    Speak("Orrin", "Sarah... oh God no...");
    FlipScreen(); FlipScreen();
    Delay(1000);
    Speak("Voice", "Twelve hours later.");
    Speak("Jedd", "I understand what you may be thinking, my daughter died because of you.");
    Speak("Orrin", "There are no words to show my sadness.");
    Speak("Jedd", "There is nothing you could have done. In such a public place... I am not going to look downly upon this, in fact, I want you to go out on a job for me... Take down one of my... competators. Can you do this?");
    Speak("Orrin", "Anything to please you.");
  }
  while(IsKeyPressed(KEY_ESCAPE)){}
  Speak("Voice", "Something's not right here...");
  CreatePerson(name, "16x16.rss", false);
  AttachCamera(name);
//  AttachInput(name);
  QueuePersonCommand(name, COMMAND_FACE_SOUTH, false);
  SetTalkActivationKey(speakKey);
  BindKey(KEY_UP, "SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, 'Walk(\"" + name + "\", 1)');", "if(!(IsKeyPressed(KEY_RIGHT) || IsKeyPressed(KEY_DOWN) || IsKeyPressed(KEY_LEFT))) SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, '')");
  BindKey(KEY_RIGHT, "SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, 'Walk(\"" + name + "\", 2)');", "if(!(IsKeyPressed(KEY_UP) || IsKeyPressed(KEY_DOWN) || IsKeyPressed(KEY_LEFT))) SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, '')");
  BindKey(KEY_DOWN, "SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, 'Walk(\"" + name + "\", 3)');", "if(!(IsKeyPressed(KEY_UP) || IsKeyPressed(KEY_RIGHT) || IsKeyPressed(KEY_LEFT))) SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, '')");
  BindKey(KEY_LEFT, "SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, 'Walk(\"" + name + "\", 4)');", "if(!(IsKeyPressed(KEY_UP) || IsKeyPressed(KEY_RIGHT) || IsKeyPressed(KEY_DOWN))) SetPersonScript('" + name + "', SCRIPT_COMMAND_GENERATOR, '')");
  BindKey(KEY_ESCAPE, "", "");
  BindKey(menuKey, "InGameMenu()", "");
  SetRenderScript("updateScript()");
  MapEngine("first town store house.rmp", 60);
  music.stop();
  if(HP) Credits();
}

function Nothing(){}

function updateScript(){
//  font.drawText(0, 0, GetPersonX("Bob") + "," + GetPersonY("Bob"));
  people = GetPersonList();
  for(var i = 0; i < people.length; i++){
    Fix(people[i]);
  }
}

function Fix(person){
  if(!IsCommandQueueEmpty(person)) return;
  var name = person;
  var x = GetPersonX(person);
  var y = GetPersonY(person);
  var dx = x%16;
  dx = 8 - dx;
  var dy = y%16;
  dy = 8 - dy;
  for(var i = 0; i < Math.abs(dx); i++){
    if(dx > 0) QueuePersonCommand(name, COMMAND_MOVE_EAST, false);
    if(dx < 0) QueuePersonCommand(name, COMMAND_MOVE_WEST, false);
  }
  for(var i = 0; i < Math.abs(dy); i++){
    if(dy > 0) QueuePersonCommand(name, COMMAND_MOVE_SOUTH, false);
    if(dy < 0) QueuePersonCommand(name, COMMAND_MOVE_NORTH, false);
  }
}

function WalkRandom(person){
  Fix(person);
  Walk(person, (Math.floor(Math.random()*4)+1), 1);
}

function Walk(person, direction, delay){
//  if(person == "Bob"){
//    if(Math.random()*100 < 8){
//      Battle();
//      SetPersonScript("Bob", SCRIPT_COMMAND_GENERATOR, "");
//      return;
//    }
//  }
  if(!delay) delay = 0;
  QueuePersonCommand(person, direction*2 - 1, true);
  direction += 8;
  for(var i = 0; i < 16; i++){
    QueuePersonCommand(person, direction, false);
    for(var j = 0; j < delay; j++){
      QueuePersonCommand(person, COMMAND_WAIT, false);
    }
  }
}

function Speak(name, text){
  DrawText(100, 20, name + ":\n\t" + text);
}

function Melt(fade_speed){
if(melt){
  var melt_length = GetScreenWidth();
  var melt_images = new Array(melt_length);
  var melt_speed = new Array(melt_length);
  var melt_offset = new Array(melt_length);
  var melt_fade = 0;
  var melt_flag = false;
  for(var i = 0; i < melt_length; i++){
    melt_images[i] = GrabImage(i, 0, 1, GetScreenHeight());
    melt_speed[i] = Math.random()*.6 + 1;
    melt_offset[i] = 0;
  }
  Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0, 0, 0));
  var melt_startTime = GetTime();
  while(!melt_flag){
    for(var i = 0; i < melt_length; i++){
      melt_images[i].blit(i, melt_offset[i]);
      melt_offset[i] += melt_speed[i];
    }
    melt_fade += fade_speed;
    if(melt_fade > 255){
      Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0,0,0));
      melt_flag = true;
    }
    Rectangle(0, 0, GetScreenWidth(), GetScreenHeight(), CreateColor(0, 0, 0, melt_fade));
    FlipScreen();
  }
  GarbageCollect();
}
}

function InGameMenu(){
  var decision = 0;
  DrawText(GetScreenWidth()/2 - font.getStringWidth("Main Menu") - 16, 20, 1, "Main Menu", false, true);
  SetClippingRectangle(16-8, 100-8, font.getStringWidth("Options") + 16, font.getHeight()*3 + 16);
  window.drawWindow(16, 100, font.getStringWidth("Options"), font.getHeight()*3);
  decision = MainMenu.blit(16, 100)
  while(!decision){
    FlipScreen();
    window.drawWindow(16, 100, font.getStringWidth("Options"), font.getHeight()*3);
    decision = MainMenu.blit(16, 100)
  }
  SetClippingRectangle(0, 0, GetScreenWidth(), GetScreenHeight());
  RenderMap();
  switch(decision){
    case(1):  Status();			break;	//Status
    case(2):  Option();			break;	//Options
    case(3):  Escape();			break;	//Exit
    case(-1): return; break;
  }
  return;
}

function Status(){
  Speak("Orrin", HP + "% health remaining.");
}

function Option(){
  var decision;
  SetClippingRectangle(16-8, 100-8, font.getStringWidth("Do not use melting effect.") + 16, font.getHeight()*3 + 16);
  window.drawWindow(16, 100, font.getStringWidth("Do not use melting effect."), font.getHeight()*3);
  decision = OptionMenu.blit(16, 100)
  FlipScreen();
  while(!decision){
    window.drawWindow(16, 100, font.getStringWidth("Do not use melting effect."), font.getHeight()*3);
    decision = OptionMenu.blit(16, 100)
    FlipScreen();
  }
  SetClippingRectangle(0, 0, GetScreenWidth(), GetScreenHeight());
  RenderMap();
  switch(decision){
    case 1: configKey(); break;
    case 2: melt = true; break;
    case 3: melt = false; break;
  }
  SetClippingRectangle(0, 0, GetScreenWidth(), GetScreenHeight());
}

function Escape(){
  var decision = 0;
  DrawText(205, 20, 1, "Do you wish to exit?", false, true);
  SetClippingRectangle(240-8, 100-8, font.getStringWidth("Yes") + 16, font.getHeight()*2 + 16);
  window.drawWindow(240, 100, font.getStringWidth("Yes"), font.getHeight()*2);
  decision = ExitMenu.blit(240, 100);
  while(!decision){
    FlipScreen();
    window.drawWindow(240, 100, font.getStringWidth("Yes"), font.getHeight()*2);
    decision = ExitMenu.blit(240, 100);
  }
  SetClippingRectangle(0, 0, GetScreenWidth(), GetScreenHeight());
  if(decision == 1) return;	// No
  if(decision == 2){		// Yes
    Melt(4); Exit();
  }
}

function Die(){
  Speak("Voice", "You have failed me.\nGood luck in the afterlife.");
  Melt(2);
  Exit();
}

function Credits(){
  var music = LoadSound("other.it");
  music.play(false);
  var red = CreateColor(255, 0, 0);
  FadeFromColor(1000, red);
  y = GetScreenHeight();
  var temp = GetTime();
  while(y > -300){
    font.drawTextBox(0, 0, GetScreenWidth(), GetScreenHeight(), y, "Credits\n\n\nStory: fenix\nIntro Images: Generated by the GIMP\nStick images: fenix\nExplosion image: fenix (yay for paint!)\nProgramming: fenix\nGod: AegisKnight\nMusic: fenix\nMaps: flik\nOriginally made for sphere's contest, but missed the deadline.\n\n\nSpecial Thanks: AegisKnight and the rest of the Sphere team, flik, People who made ModPlugTracker, People who made the GIMP, and probably some other people I missed. Thanks everyone!");
    FlipScreen();
    y = (1 - ((GetTime() - temp)/50000))*(GetScreenHeight() + 300) - 300;
  }
  music.stop();
  music = LoadSound("intro.it");
  music.play(false);
  while(!IsKeyPressed(KEY_ESCAPE)){
    font.drawText(0, 0, "Press escape to exit.")
    font.drawText(0, 20, "This music was for shits and giggles.");
    FlipScreen();
  }
}